
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalogClient.schemas;
import es.gva.cit.catalogClient.filters.AdditionalClauses;
import java.util.StringTokenizer;

/**
 * This class defines the labels for the ebXML CSW Profile.
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class EbRIMSchema implements ISchemas {

/**
 * 
 * 
 * 
 * @return 
 */
    public String getTitle() {        
        return "/Dataset/Name/LocalizedString/@value";
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getAbstract() {        
        return "/Dataset/Description/LocalizedString/@value";
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getThemeKey() {        
        return "/Dataset/Slot:s2/ValueList/Value";
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getTopic() {        
        return "/Classification/@classificationNode";
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getScale() {        
        return null;
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getProvider() {        
        return "/Organization/Name/LocalizedString/@value";
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getDateFrom() {        
        return null;
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getDateTo() {        
        return null;
    } 

/**
 * 
 * 
 * 
 * @return 
 * @param topic 
 */
    public String getTopicValue(String topic) {        
        if (topic.equals("farming")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:001";
        }
        if (topic.equals("biota")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:002";
        }
        if (topic.equals("boundaries")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:003";
        }
        if (topic.equals("climatologyMeteorologyAtmosphere")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:004";
        }
        if (topic.equals("economy")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:005";
        }
        if (topic.equals("elevation")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:006";
        }
        if (topic.equals("environment")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:007";
        }
        if (topic.equals("geoscientificInformation")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:008";
        }
        if (topic.equals("health")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:009";
        }
        if (topic.equals("imageryBaseMapsEarthCover")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:010";
        }
        if (topic.equals("intelligenceMilitary")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:011";
        }
        if (topic.equals("inlandWaters")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:012";
        }
        if (topic.equals("location")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:013";
        }
        if (topic.equals("oceans")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:014";
        }
        if (topic.equals("planningCadastre")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:015";
        }
        if (topic.equals("society")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:016";
        }
        if (topic.equals("structure")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:017";
        }
        if (topic.equals("transportation")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:018";
        }
        if (topic.equals("utilitiesCommunication")) {
            return "urn:x-iso-tc211:19119(2003)/scheme/services/scheme/topics:019";
        }
        return "";
    } 

/**
 * 
 * 
 * 
 * @return 
 * @param dataset 
 */
    public AdditionalClauses[] getAdditionalClauses(String[] dataset) {        
        AdditionalClauses[] ac = new AdditionalClauses[3];
        //Classification
        ac[0] = new AdditionalClauses("/Dataset/@id",
                "/Classification/@classifiedObject", "E", "PropertyIsEqualTo",
                "P");
        //Association
        ac[1] = new AdditionalClauses("/Dataset/@id",
                "/Association/@sourceObject", "E", "PropertyIsEqualTo", "P");
        //Geometry
        ac[2] = new AdditionalClauses("/Geometry/@id",
                "/Association/@targetObject", "E", "PropertyIsEqualTo", "P");
        return ac;
    } 

/**
 * 
 * 
 * 
 * @return 
 * @param title 
 * @param filter 
 */
    public String getTitleValue(String title, String filter) {        
		if (filter.equals("E"))
			return "*" + title + "*";
		
		StringTokenizer sti = new StringTokenizer(title);
		String pattern = "";
		
		while (sti.hasMoreElements())
			pattern = pattern + "*" + sti.nextToken() + "* ";
		
		
		return pattern;
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getProviderValue(java.lang.String)
     */

/**
 * 
 * 
 * 
 * @return 
 * @param value 
 */
    public String getProviderValue(String value) {        
        // TODO Auto-generated method stub
        return null;
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getCoordinates() {        
        return "/Geometry/content";
    } 
 }
