
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalogClient.ui.search;
import es.gva.cit.catalogClient.schemas.Schemas;
import com.iver.utiles.swing.jcomboServer.ServerData;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.gvsig.i18n.Messages;

/**
 * 
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class SearchUpperPanel extends JPanel {
/**
 * 
 * 
 */
    private JTextField tituloText = null;
/**
 * 
 * 
 */
    private JPanel panelLabTitulo = null;
/**
 * 
 * 
 */
    private JLabel tituloLabel = null;
/**
 * 
 * 
 */
    private JPanel panelCheckBox = null;
/**
 * 
 * 
 */
    private JPanel panelTextTitulo = null;
/**
 * 
 * 
 */
    private JCheckBox coordinatesCheckBox = null;
/**
 * 
 * 
 */
    private JPanel upperPanel = null;
/**
 * 
 * 
 */
    private JPanel upperLeftPanel = null;
/**
 * 
 * 
 */
    private JPanel upperRightPanel = null;
/**
 * 
 * 
 */
    private JPanel jPanel1 = null;
/**
 * 
 * 
 */
    private JButton sizeButton = null;
/**
 * 
 * 
 */
    private JPanel jPanel4 = null;

/**
 * This method initializes
 * 
 * 
 * @param translator 
 * @param type 
 * @param profile 
 */
    public  SearchUpperPanel(String type, String profile) {        
        super();
        initialize();
        disableComponents(type,profile);
    } 

/**
 * This method initializes this
 * 
 */
    private void initialize() {        
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        setLocation(0, 0);
        setSize(675, 50);
        setPreferredSize(new java.awt.Dimension(510,50));
        add(getUpperPanel(), null);
    } 

/**
 * This method initializes jTextField
 * 
 * 
 * @return javax.swing.JTextField
 */
    private JTextField getTituloText() {        
        if (tituloText == null) {
            tituloText = new JTextField();
            tituloText.setPreferredSize(new java.awt.Dimension(250,20));
        }
        return tituloText;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelLabTitulo() {        
        if (panelLabTitulo == null) {
            GridLayout gridLayout10 = new GridLayout();
            tituloLabel = new JLabel();
            panelLabTitulo = new JPanel();
            panelLabTitulo.setLayout(gridLayout10);
            tituloLabel.setText(Messages.getText("title"));
            gridLayout10.setRows(1);
            panelLabTitulo.add(tituloLabel, null);
        }
        return panelLabTitulo;
    } 

/**
 * This method initializes jPanel1
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelCheckBox() {        
        if (panelCheckBox == null) {
            panelCheckBox = new JPanel();
            panelCheckBox.setLayout(new BoxLayout(panelCheckBox, BoxLayout.X_AXIS));
            panelCheckBox.setPreferredSize(new java.awt.Dimension(310,30));
            panelCheckBox.add(getCoordinatesCheckBox(), null);
            panelCheckBox.add(getJPanel4(), null);
        }
        return panelCheckBox;
    } 

/**
 * This method initializes jPanel9
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelTextTitulo() {        
        if (panelTextTitulo == null) {
            panelTextTitulo = new JPanel();
            panelTextTitulo.add(getTituloText(), null);
        }
        return panelTextTitulo;
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.ui.ISearchPanel#getTitle()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getTitle() {        
        if (getTituloText().getText().equals("")) {
            return null;
        }
        return getTituloText().getText();
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.ui.ISearchPanel#getRestrictAreaClicked()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public boolean getRestrictAreaClicked() {        
        // TODO Auto-generated method stub
        return coordinatesCheckBox.isSelected();
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.ui.ISearchPanel#setTitle(java.lang.String)
     */

/**
 * 
 * 
 * 
 * @param title 
 */
    public void setTitle(String title) {        
        getTituloText().setText(title);
        
    } 

/**
 * This method initializes jCheckBox
 * 
 * 
 * @return javax.swing.JCheckBox
 */
    public JCheckBox getCoordinatesCheckBox() {        
		if (coordinatesCheckBox == null) {
			coordinatesCheckBox = new JCheckBox();
			coordinatesCheckBox.setText(Messages.getText("restrictArea"));
		}
		return coordinatesCheckBox;
    } 

/**
 * This method initializes jPanel1
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getUpperPanel() {        
		if (upperPanel == null) {
			upperPanel = new JPanel();
			upperPanel.setLayout(new FlowLayout());
			upperPanel.setPreferredSize(new java.awt.Dimension(510,50));
			upperPanel.add(getUpperLeftPanel(), null);
			upperPanel.add(getUpperRightPanel(), null);
		}
		return upperPanel;
    } 

/**
 * This method initializes jPanel1
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getUpperLeftPanel() {        
		if (upperLeftPanel == null) {
			upperLeftPanel = new JPanel();
			upperLeftPanel.setLayout(new BoxLayout(upperLeftPanel, BoxLayout.Y_AXIS));
			upperLeftPanel.setPreferredSize(new java.awt.Dimension(250,45));
			upperLeftPanel.add(getPanelLabTitulo(), null);
			upperLeftPanel.add(getPanelTextTitulo(), null);
		}
		return upperLeftPanel;
    } 

/**
 * This method initializes jPanel4
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getUpperRightPanel() {        
		if (upperRightPanel == null) {
			upperRightPanel = new JPanel();
			upperRightPanel.setLayout(new BoxLayout(upperRightPanel, BoxLayout.Y_AXIS));
			upperRightPanel.setPreferredSize(new java.awt.Dimension(250,45));
			upperRightPanel.add(getJPanel1(), null);
			upperRightPanel.add(getPanelCheckBox(), null);
		}
		return upperRightPanel;
    } 

/**
 * This method initializes jPanel1
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel1() {        
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setPreferredSize(new java.awt.Dimension(37,15));
		}
		return jPanel1;
    } 

/**
 * This method initializes jButton
 * 
 * 
 * @return javax.swing.JButton
 */
    public JButton getSizeButton() {        
		if (sizeButton == null) {
			sizeButton = new JButton();
	        sizeButton.setPreferredSize(new java.awt.Dimension(18,18));
	        setDownIcon();
		}
		return sizeButton;
    } 

/**
 * This method initializes jPanel4
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel4() {        
		if (jPanel4 == null) {
			jPanel4 = new JPanel();
			jPanel4.add(getSizeButton(), null);
		}
		return jPanel4;
    } 

/**
 * It sets the icon image up
 * 
 */
    public void setUpIcon() {        
	    sizeButton.setIcon(new ImageIcon("./gvSIG/extensiones/es.gva.cit.gvsig.catalogClient/images/up.png"));
    } 

/**
 * It sets the icon image down
 * 
 */
    public void setDownIcon() {        
	    sizeButton.setIcon(new ImageIcon("./gvSIG/extensiones/es.gva.cit.gvsig.catalogClient/images/down.png"));
    } 

/**
 * This methos disables the components that are representing
 * fileds that the protocol used to do the search doesn't
 * support
 * 
 * 
 * @param type Server type: Z3950, SRW or CSW
 * @param profile Server Profile: DUBLINCORE, ISO19115, ebRIM
 */
    private void disableComponents(String type, String profile) {        
        //System.out.println("TYPE: " + type);
        //System.out.println("SUBTYPE: " + profile);
        
        if (type.equals(ServerData.SERVER_SUBTYPE_CATALOG_SRW) ||
                profile.equals(Schemas.ISO19115) ||
                profile.equals(Schemas.DUBLINCORE)){
            getCoordinatesCheckBox().setEnabled(false);
        }
    } 
 }
//  @jve:decl-index=0:visual-constraint="10,10"
