/*
 * Created on 17-feb-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import java.awt.Component;
import java.awt.Image;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.plugins.Extension;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.project.documents.view.gui.View;
import com.iver.utiles.GenericFileFilter;
import com.sun.jimi.core.Jimi;
import com.sun.jimi.core.JimiException;
import com.sun.jimi.core.raster.JimiRasterImage;


/**
 * Extensin para exportar en algunos formatos raster la vista actual.
 *
 * @author Fernando Gonzlez Corts
 */
public class Export extends Extension {
	private String lastPath = null;

	/**
	 * @see com.iver.andami.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
		View f = (View) PluginServices.getMDIManager().getActiveWindow();

		if (f == null) {
			return false;
		}

		FLayers layers = f.getModel().getMapContext().getLayers();
		for (int i=0;i< layers.getLayersCount();i++) {
			return layers.getLayer(i).isAvailable();
		}
		return false;
	}

	/**
	 * @see com.iver.mdiApp.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		com.iver.andami.ui.mdiManager.IWindow f = (com.iver.andami.ui.mdiManager.IWindow) PluginServices.getMDIManager()
																								  .getActiveWindow();

		if (f == null) {
			return false;
		}

		return (f instanceof View);
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
	 */
	public void execute(String actionCommand) {
		FileFilter pngFilter = new GenericFileFilter("png",
				PluginServices.getText(this, "png"));
		String[] s={"jpg","jpeg"};
		FileFilter jpgFilter = new GenericFileFilter(s,
				PluginServices.getText(this, "jpg"));
		FileFilter bmpFilter = new GenericFileFilter("bmp",
				PluginServices.getText(this, "bmp"));

		JFileChooser jfc = new JFileChooser(lastPath);
		jfc.addChoosableFileFilter(pngFilter);
		jfc.addChoosableFileFilter(jpgFilter);
		jfc.addChoosableFileFilter(bmpFilter);
		jfc.setFileFilter(pngFilter);
		if (jfc.showSaveDialog((Component) PluginServices.getMainFrame()) == JFileChooser.APPROVE_OPTION) {
			Image tempImage;

			tempImage = ((View) PluginServices.getMDIManager().getActiveWindow()).getImage();

			File f = jfc.getSelectedFile();

			try {
				JimiRasterImage jrf = Jimi.createRasterImage(tempImage.getSource());
				String tempName = f.getName().toUpperCase().trim();
				if (jfc.getFileFilter().equals(pngFilter)){
					System.out.println("pngFilter");
					if (!(tempName.length()>3) || (!(tempName.substring(tempName.length()-4,tempName.length()).equalsIgnoreCase(".png")))){
						f=new File(f.getPath()+".png");
					}
						FileOutputStream fout = new FileOutputStream(f);
						Jimi.putImage("image/png", jrf, fout);
						fout.close();
				} else if (jfc.getFileFilter().equals(bmpFilter)){
					System.out.println("bmpFilter");
					if (!(tempName.length()>3) || (!(tempName.substring(tempName.length()-4,tempName.length()).equalsIgnoreCase(".bmp")))){
						f=new File(f.getPath()+".bmp");
					}
						FileOutputStream fout = new FileOutputStream(f);
						Jimi.putImage("image/bmp", jrf, fout);
						fout.close();
				}else if (jfc.getFileFilter().equals(jpgFilter)){
					System.out.println("jpgFilter");
					if (!(tempName.length()>3) || ((tempName.length()>3 && !(tempName.substring(tempName.length()-4,tempName.length()).equalsIgnoreCase(".jpg")) || (tempName.length()>4 &&tempName.substring(tempName.length()-5,tempName.length()).equalsIgnoreCase(".jpeg"))))){
						f=new File(f.getPath()+".jpg");
					}
						FileOutputStream fout = new FileOutputStream(f);
						Jimi.putImage("image/jpg", jrf, fout);
						fout.close();

				}
				String filePath = f.getAbsolutePath();
				lastPath = filePath.substring(0, filePath.lastIndexOf(File.separatorChar));
				/*if (tempName.endsWith(".JPG")) {

					FileOutputStream fout = new FileOutputStream(f);
					Jimi.putImage("image/jpg", jrf, fout);
					fout.close();
				} else if (tempName.endsWith(".PNG")) {
					FileOutputStream fout = new FileOutputStream(f);
					Jimi.putImage("image/png", jrf, fout);
					fout.close();
				} else if (tempName.endsWith(".BMP")) {
					FileOutputStream fout = new FileOutputStream(f);
					Jimi.putImage("image/bmp", jrf, fout);
					fout.close();
				}
				*/
			} catch (JimiException e) {
				NotificationManager.addError("Error exportando la imagen", e);
			} catch (FileNotFoundException e) {
				NotificationManager.addError("No se encontr el fichero", e);
			} catch (IOException e) {
				NotificationManager.addError("Error con el fichero", e);
			}
		}
	}
}
