package com.iver.cit.gvsig.project.documents.view.toc.actions;

import java.awt.Color;

import javax.swing.JColorChooser;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.core.v02.FSymbol;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.layerOperations.ClassifiableVectorial;
import com.iver.cit.gvsig.fmap.rendering.SingleSymbolLegend;
import com.iver.cit.gvsig.project.documents.view.toc.AbstractTocContextMenuAction;
import com.iver.cit.gvsig.project.documents.view.toc.ITocItem;
import com.iver.cit.gvsig.project.documents.view.toc.TocItemLeaf;
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: FSymbolChangeColorTocMenuEntry.java,v 1.4 2006/10/02 13:52:34 jaume Exp $
 * $Log: FSymbolChangeColorTocMenuEntry.java,v $
 * Revision 1.4  2006/10/02 13:52:34  jaume
 * organize impots
 *
 * Revision 1.3  2006/09/29 07:07:41  caballero
 * llamada a listener
 *
 * Revision 1.2  2006/09/28 15:00:45  fjp
 * Usar siempre que se pueda ISymbol en lugar de FSymbol
 *
 * Revision 1.1  2006/09/15 10:41:30  caballero
 * extensibilidad de documentos
 *
 * Revision 1.1  2006/09/12 15:58:14  jorpiell
 * "Sacadas" las opcines del men de FPopupMenu
 *
 *
 */
/**
 * Realiza el cambio de color si se pulsa OK
 * @author Luis W. Sevilla (sevilla_lui@gva.es)
 */
public class FSymbolChangeColorTocMenuEntry extends AbstractTocContextMenuAction {
	public String getGroup() {
		return "group1"; //FIXME
	}

	public int getGroupOrder() {
		return 10;
	}

	public int getOrder() {
		return 0;
	}

	public String getText() {
		return PluginServices.getText(this, "Cambio_Color");
	}

	public boolean isEnabled(ITocItem item, FLayer[] selectedItems) {
		return true;
	}

	public boolean isVisible(ITocItem item, FLayer[] selectedItems) {
		boolean bShow = false;
		if (isTocItemBranch(item))
		{
			FLayer lyr = getNodeLayer(item);
    		if ((lyr instanceof ClassifiableVectorial))
    		{
    		    ClassifiableVectorial lyrVect = (ClassifiableVectorial) lyr;
    		    if (lyrVect.getLegend() instanceof SingleSymbolLegend)
    		    	if (lyrVect.getLegend().getDefaultSymbol() instanceof FSymbol)
    		        bShow = true;
    		}
		} else if (isTocItemLeaf(item)) {
		    //bShow = true;

		}
		return bShow;
	}

	public void execute(ITocItem item, FLayer[] selectedItems) {

		boolean showDialog=false;
		if (isTocItemBranch(item)) {
			FLayer[] actives = getMapContext().getLayers().getActives();
			if (actives.length > 0) {
                for (int i=0;i<actives.length;i++){
                    if ((actives[i] instanceof ClassifiableVectorial))
                    {
                        ClassifiableVectorial lyrVect = (ClassifiableVectorial) actives[i];
                        if (lyrVect.getLegend() instanceof SingleSymbolLegend && actives[i].isAvailable() )
                        {
                            showDialog=true;
                            break;
                        }
                    }
                }
			}
		}

		if (!showDialog) return;

        Color newColor = JColorChooser.showDialog(null,
                PluginServices.getText(this, "Elegir_Color"),
                null);
        if (newColor != null)
        {
			if (isTocItemBranch(item))
			{
				//FLayer lyr = getNodeLayer();
                FLayer[] actives = getMapContext().getLayers().getActives();
                for (int i=0;i<actives.length;i++){
                    if ((actives[i] instanceof ClassifiableVectorial))
                    {
                        ClassifiableVectorial lyrVect = (ClassifiableVectorial) actives[i];
                        if (lyrVect.getLegend() instanceof SingleSymbolLegend)
                        {
                            SingleSymbolLegend leg = (SingleSymbolLegend) lyrVect.getLegend();
                            ((FSymbol)leg.getDefaultSymbol()).setColor(newColor);
                        }
                    }
                }
			}
			else
			{
    	        TocItemLeaf leaf = (TocItemLeaf) item;
    	        FSymbol sym = (FSymbol) leaf.getSymbol();
    	        sym.setColor(newColor);

			}
	        // TRUCO PARA REFRESCAR.
	        getMapContext().invalidate();
			getMapContext().callLegendChanged();
        }

	}
}

