package com.iver.cit.gvsig.project.documents.view.toc.actions;

import java.awt.event.ActionEvent;

import javax.swing.JMenuItem;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.project.documents.view.gui.View;
import com.iver.cit.gvsig.project.documents.view.toc.TocMenuEntry;
import com.iver.cit.gvsig.project.documents.view.toc.gui.FPopupMenu;


/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: SaveRasterTocMenuEntry.java,v 1.1 2006/09/15 10:41:30 caballero Exp $
 * $Log: SaveRasterTocMenuEntry.java,v $
 * Revision 1.1  2006/09/15 10:41:30  caballero
 * extensibilidad de documentos
 *
 * Revision 1.1  2006/09/12 15:58:14  jorpiell
 * "Sacadas" las opcines del men de FPopupMenu
 *
 *
 */
/**
*
* @author Nacho Brodin <brodin_ign@gva.es>
*
* Entrada de men para la activacin de la funcionalidad de salvar
* a raster una parte de la vista.
*/
public class SaveRasterTocMenuEntry extends TocMenuEntry{
	private JMenuItem properties;
	FLayer lyr = null;

	public void initialize(FPopupMenu m) {
		super.initialize(m);

		if (isTocItemBranch()) {
			lyr = getNodeLayer();
   		// Opcciones para capas raster
   		if ((lyr instanceof FLyrRaster)) {
   			properties = new JMenuItem(PluginServices.getText(this, "salvar_raster"));
   			getMenu().add( properties );
   			properties.setFont(FPopupMenu.theFont);
   			getMenu().setEnabled(true);
   			//getMenu().addSeparator();
   	        //Cambio color
   			properties.addActionListener(this);
    		}
		}
	}

	public void actionPerformed(ActionEvent e) {
		lyr = getNodeLayer();
		View vista = (View) PluginServices.getMDIManager().getActiveWindow();
		MapControl mapCtrl = vista.getMapControl();
		mapCtrl.setTool("saveRaster");
	}
}

