package es.prodevelop.cit.gvsig.arcims.fmap.drivers;

import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import org.cresques.cts.ICoordTrans;
import org.cresques.cts.IProjection;
import org.cresques.io.GdalFile;
import org.cresques.io.GeoRasterFile;
import org.cresques.filter.RasterFilterStack;
import org.cresques.filter.RasterStats;

import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.drivers.RasterDriver;

public class ArcImsRasterDriver implements RasterDriver {
	
	private Rectangle2D fullExtent;
	private int numBands, width, height;
	private int rband = 0;
	private int gband = 1;
	private int bband = 2;
	private int transparency = 128;
	private boolean hasTransparency;
	private RasterFilterStack filterStack;
	private String fileName = "";
	
	private ArrayList grfiles;
	private IProjection projection;
	
	public ArcImsRasterDriver() {
		GeoRasterFile.registerExtension("gif", GdalFile.class);
	}

	public boolean fileAccepted(File fName) {
		// TODO Auto-generated method stub
		return false;
	}

	public void open(File f) throws IOException {
		// TODO Auto-generated method stub

	}

	public void initialize() throws IOException {
		// TODO Auto-generated method stub

	}

	public void close() throws IOException {
		// TODO Auto-generated method stub

	}

	public Rectangle2D getFullExtent() {
		return fullExtent;
	}

	public int getNumBands() {
		return numBands;
	}

	public int getTransparency() {
		return transparency;
	}

	public void setTransparency(int trans) {
		transparency = trans;
	}

	public void draw(BufferedImage image, Graphics2D g, ViewPort viewPort)
			throws DriverIOException {
		// TODO Auto-generated method stub

	}

	public int getRasterDataType() {
		// TODO Auto-generated method stub
		return 0;
	}

	public Object getData(int x, int y, int band) {
		// TODO Auto-generated method stub
		return null;
	}

	public int getDataAsInt(int x, int y, int band) {
		// TODO Auto-generated method stub
		return 0;
	}

	public byte getDataAsByte(int x, int y, int band) {
		// TODO Auto-generated method stub
		return 0;
	}

	public float getDataAsFloat(int x, int y, int band) {
		// TODO Auto-generated method stub
		return 0;
	}

	public double getDataAsDouble(int x, int y, int band) {
		// TODO Auto-generated method stub
		return 0;
	}

	public Image getImage(Dimension size, Rectangle2D userSize, ICoordTrans rp) {
		// TODO Auto-generated method stub
		return null;
	}

	public ArrayList getAttributes() {
		// TODO Auto-generated method stub
		Object[] _filename = new Object[2];
		_filename[0] = new String("Filename");
		_filename[1] = new String(fileName);
		
		Object[] _filesize = new Object[2];
		_filesize[0] = new String("Filesize");
		_filesize[1] = new Long(0);
		
		Object[] _width = new Object[2];
		_width[0] = new String("Width");
		_width[1] = new Integer(width);
		
		Object[] _height = new Object[2];
		_height[0] = new String("Height");
		_height[1] = new Integer(height);
		
		ArrayList resp = new ArrayList();
		resp.add(_filename);
		resp.add(_filesize);
		resp.add(_width);
		resp.add(_height);
		
		return resp;
	}

	public int getBand(int flag) {
		switch (flag) {
		case GeoRasterFile.RED_BAND:
			return rband;
		case GeoRasterFile.GREEN_BAND:
			return gband;
		case GeoRasterFile.BLUE_BAND:
			return bband;
		}
		return -1;
	}

	public int getPosFile(int flag) {
		return -1;
	}

	public void setTransparency(boolean t) {
		hasTransparency = t;
	}

	public void setBand(int flag, int nBand) {
		switch (flag) {
		case GeoRasterFile.RED_BAND:
			rband = nBand;
			break;
		case GeoRasterFile.GREEN_BAND:
			gband = nBand;
			break;
		case GeoRasterFile.BLUE_BAND:
			bband = nBand;
			break;
		}
	}

	public RasterFilterStack getFilterStack() {
		return filterStack;
	}

	public void setFilterStack(RasterFilterStack stack) {
		filterStack = stack;
	}

	public GeoRasterFile[] getFiles() {
		GeoRasterFile[] resp = new GeoRasterFile[grfiles.size()];
		for (int i=0; i<grfiles.size(); i++) {
			resp[i] = GeoRasterFile.openFile(projection, (String) grfiles.get(i)); 
		}
		return resp;
	}
	
	public void clearFiles() {
		if (grfiles == null) {
			grfiles = new ArrayList();
		}
		grfiles.clear();
	}
	
	public void addFile(String fileName) {
		
		int ind = containsStr(grfiles, fileName);
		if (ind == -1) {
			grfiles.add(fileName);
		}
	}
	
	private int containsStr(ArrayList list, String str) {
		String aux;
		for (int i=0; i<list.size(); i++) {
			aux = (String) list.get(i);
			if (str.compareToIgnoreCase(aux) == 0) {
				return i;
			}
		}
		return -1;
	}

	public void delFile(String fileName) {
		int ind = containsStr(grfiles, fileName);
		if (ind != -1) {
			grfiles.remove(ind);
		}
	}

	public int[] getPixel(double wcx, double wcy) {
		// TODO Auto-generated method stub
		return null;
	}

	public String getName() {
		// TODO Auto-generated method stub
		return "ArcImsRasterFilterStack";
	}

	public void setHeight(int height) {
		this.height = height;
	}

	public void setWidth(int width) {
		this.width = width;
	}

	public void setFullExtent(Rectangle2D fullExtent) {
		this.fullExtent = fullExtent;
	}

	public void setNumBands(int n) {
		numBands = n;
	}

	public void setFileName(String name) {
		fileName = name;
	}

	public void setProjection(IProjection proj) {
		projection = proj;
	}

	public boolean isGeoreferenced() {
		return true;
	}

}
