/*
 * Created on 22-jun-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
*
* $Id: ClipGeoprocessPlugin.java,v 1.5 2006/09/15 10:42:54 caballero Exp $
* $Log: ClipGeoprocessPlugin.java,v $
* Revision 1.5  2006/09/15 10:42:54  caballero
* extensibilidad de documentos
*
* Revision 1.4  2006/08/29 07:56:30  cesar
* Rename the *View* family of classes to *Window* (ie: SingletonView to SingletonWindow, ViewInfo to WindowInfo, etc)
*
* Revision 1.3  2006/08/11 16:19:01  azabala
* *** empty log message ***
*
* Revision 1.2  2006/06/27 16:11:41  azabala
* toString() added to Plugin interface to force textual representation of geoprocess plugins
*
* Revision 1.1  2006/06/23 19:02:35  azabala
* first version in cvs
*
* Revision 1.1  2006/06/22 17:46:30  azabala
* first version in cvs
*
*
*/
package com.iver.cit.gvsig.geoprocess.impl.clip;

import java.net.URL;
import java.util.Locale;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessController;
import com.iver.cit.gvsig.geoprocess.core.IGeoprocessPlugin;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoProcessingOverlayPanel;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoProcessingOverlayPanel2;
import com.iver.cit.gvsig.geoprocess.core.gui.IGeoprocessPanel;
import com.iver.cit.gvsig.geoprocess.impl.buffer.BufferGeoprocessPlugin;
import com.iver.cit.gvsig.geoprocess.manager.GeoprocessManager;
import com.iver.cit.gvsig.project.documents.view.gui.View;

public class ClipGeoprocessPlugin implements IGeoprocessPlugin {
	private static String analisisPkg;
	private static String overlayPkg;
	private static String overlayPkgDesc;
	private static String geoprocessName;
	
	static{
		analisisPkg = PluginServices.getText(null, "Analisis");
		overlayPkg = PluginServices.getText(null, "Overlay");
		overlayPkgDesc = PluginServices.getText(null, "Overlay_Desc");
		geoprocessName = PluginServices.getText(null, "Recortar");
		
//		GeoprocessManager.registerPackageDescription(
//		"Analisis/Overlay",
//				"Geoprocesos que extraen "+
//				"informacin basandose en "+
//				"la superposicin de dos capas");
		GeoprocessManager.registerPackageDescription(
				analisisPkg + "/" + overlayPkg,
						overlayPkgDesc);

	}
	
	public IGeoprocessPanel getGeoprocessPanel() {
		View vista = (View)PluginServices.
			getMDIManager().
			getActiveWindow();
		FLayers layers = vista.getModel().
			getMapContext().
			getLayers();
		String titleText = PluginServices.getText(this,
			"Recortar._Introduccion_de_datos")
			+ ":";
		return new GeoProcessingOverlayPanel2(layers, titleText);
	}

	public URL getHtmlDescription() {
		Locale locale = Locale.getDefault();
		String localeStr = locale.getLanguage();
		String urlStr = "resources/description_" +
										localeStr +
											".html";	
		return ClipGeoprocessPlugin.class.
			getResource(urlStr);
	}

	public URL getImgDescription() {
		return ClipGeoprocessPlugin.class.
		getResource("resources/clipdesc.png");
	}

	public IGeoprocessController getGpController() {
		return new ClipGeoprocessController();
	}

	public String getNamespace() {
		return analisisPkg + "/" + 
				overlayPkg + "/" + 
				geoprocessName;
	}

	public String toString(){
		return geoprocessName;
	}

}

