package com.iver.cit.gvsig.fmap.drivers.wfs;

import java.awt.Component;

import javax.swing.JOptionPane;

import org.cresques.cts.ICoordTrans;
import org.cresques.cts.IProjection;
import org.cresques.cts.ProjectionPool;
import org.gvsig.remoteClient.gml.GMLException;
import org.gvsig.remoteClient.gml.IGMLFeaturesIterator;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.IFeature;
import com.iver.cit.gvsig.fmap.drivers.IFeatureIterator;
import com.iver.cit.gvsig.fmap.drivers.gml.FMAPGeometryFactory.FeatureWithAttributes;


/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSFeaturesIterator.java,v 1.3 2006/10/02 09:09:45 jorpiell Exp $
 * $Log: WFSFeaturesIterator.java,v $
 * Revision 1.3  2006/10/02 09:09:45  jorpiell
 * Cambios del 10 copiados al head
 *
 * Revision 1.1.2.2  2006/09/26 07:36:23  jorpiell
 * El WFS no reproyectaba porque no se le asignaba a la capa un sistema de referencia. Ahora ya se hace.
 *
 * Revision 1.1.2.1  2006/09/19 12:28:32  jorpiell
 * Ya no se depende de geotools
 *
 * Revision 1.1  2006/09/18 12:07:31  jorpiell
 * Se ha sustituido geotools por el driver de remoteservices
 *
 * Revision 1.10  2006/08/29 07:56:12  cesar
 * Rename the *View* family of classes to *Window* (ie: SingletonView to SingletonWindow, ViewInfo to WindowInfo, etc)
 *
 * Revision 1.9  2006/07/24 07:30:33  jorpiell
 * Se han eliminado las partes duplicadas y se est usando el parser de GML de FMAP.
 *
 * Revision 1.8  2006/07/05 12:05:54  jorpiell
 * Se ha modificado para que avise si se han recuperado las mismas features que marca el campo buffer
 *
 * Revision 1.6  2006/06/21 12:35:45  jorpiell
 * Se ha aadido la ventana de propiedades. Esto implica aadir listeners por todos los paneles. Adems no se muestra la geomatra en la lista de atributos y se muestran nicamnete los que se van a descargar
 *
 * Revision 1.5  2006/06/15 11:17:06  jorpiell
 * Se ha encontrado la forma de comprobar cuando se prodicia un error de parseo al hacer un hasnext (en la feature). Se atrapa y se lanza la excepcin hacia arriba
 *
 * Revision 1.4  2006/06/15 07:50:58  jorpiell
 * Aadida la funcionalidad de reproyectar y hechos algunos cambios en la interfaz
 *
 * Revision 1.3  2006/05/23 13:21:12  jorpiell
 * Modificado el datasource para capturar las excepciones de parseo
 *
 * Revision 1.2  2006/05/22 10:10:07  jorpiell
 * El iteartor crea un vector y lo inicializa en el primer recorrido que se hace sobre l. A partir de ah se devuelve un elemento del vector en los posteriores recorridos
 *
 * Revision 1.1  2006/05/19 12:47:12  jorpiell
 * Creado el iteardor de Features
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class WFSFeaturesIterator implements IFeatureIterator{
	private ICoordTrans coordTrans = null;	
	private IGMLFeaturesIterator iterator = null;
	
	public WFSFeaturesIterator(IGMLFeaturesIterator iterator,String sProjection){
		this.iterator = iterator;		
	}

	public boolean hasNext() throws DriverException {
		System.out.println("ir");
		try {
			return iterator.hasNext();
		} catch (GMLException e) {
			throw new DriverException(e.getMessage());
		}
	}

	public IFeature next() throws DriverException {
		try {
			return ((FeatureWithAttributes)iterator.next()).getFeature();
		} catch (GMLException e) {
			throw new DriverException(e.getMessage());
		}
	}

	public void closeIterator() throws DriverException {
				
	}	
	
	
}
