/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.ui;

import java.awt.Cursor;
import java.awt.Point;
import java.awt.Toolkit;


/**
 * @author "Luis W. Sevilla" <sevilla_lui@gva.es>
 */
public class CQCursor {
    public static int ZOOMIN_CURSOR = 0x100;
    public static int ZOOMOUT_CURSOR = 0x101;
    public static int PAN_CURSOR = 0x102;
    public static int SELECT_CURSOR = 0x103;
    public static int INFO_CURSOR = 0x104;
    private static int MAXCURSORNR = 15;
    private static Cursor[] cursores = null;

    static {
        ClassLoader loader = CQCursor.class.getClassLoader();

        //ImageIcon folderIcon = new ImageIcon(loader.getResource("images/"+"folderXP.gif"));
        cursores = new Cursor[MAXCURSORNR];
        cursores[ZOOMIN_CURSOR - 0x100] = Toolkit.getDefaultToolkit()
                                                 .createCustomCursor(Toolkit.getDefaultToolkit()
                                                                            .getImage(loader.getResource("images/zi_cur.gif")),
                                                                     new Point(6,
                                                                               5),
                                                                     "ZoomMas");
        cursores[ZOOMOUT_CURSOR - 0x100] = Toolkit.getDefaultToolkit()
                                                  .createCustomCursor(Toolkit.getDefaultToolkit()
                                                                             .getImage(loader.getResource("images/zo_cur.gif")),
                                                                      new Point(6,
                                                                                5),
                                                                      "ZoomMenos");
        cursores[PAN_CURSOR - 0x100] = Toolkit.getDefaultToolkit()
                                              .createCustomCursor(Toolkit.getDefaultToolkit()
                                                                         .getImage(loader.getResource("images/pan_cur.gif")),
                                                                  new Point(3, 3),
                                                                  "Pan");
        cursores[SELECT_CURSOR - 0x100] = Toolkit.getDefaultToolkit()
                                                 .createCustomCursor(Toolkit.getDefaultToolkit()
                                                                            .getImage(loader.getResource("images/select_cur.gif")),
                                                                     new Point(6,
                                                                               1),
                                                                     "Select");
        cursores[INFO_CURSOR - 0x100] = Toolkit.getDefaultToolkit()
                                               .createCustomCursor(Toolkit.getDefaultToolkit()
                                                                          .getImage(loader.getResource("images/info_cur.gif")),
                                                                   new Point(5,
                                                                             26),
                                                                   "Info");
    }

    public static Cursor getCursor(int type) {
        Cursor cursor = null;

        if (type < 0x100) {
            cursor = new Cursor(type);
        } else if (type >= 0x100) {
            cursor = cursores[type - 0x100];
        }

        return cursor;
    }
}
