/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.drivers;

import java.awt.geom.Rectangle2D;
import java.sql.Connection;

import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.IFeature;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.layers.XMLException;
import com.iver.utiles.XMLEntity;

public interface VectorialDatabaseDriver extends  VectorialDriver {
    /**
     * @param conn
     * @param tableName
     * @param fields (Todos los campos, el primero ha de ser el de las geometras
     * @param whereClause
     * @param id_FID_field El identificador del campo que contiene una clave nica. 1=> primer campo, 2 => segundo campo, etc
     * 
     */
    // public void setData(Connection conn, String tableName, String fields, String whereClause, int id_FID_field);
    public Rectangle2D getFullExtent();
    public int getShapeType();
    
    public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG) throws DriverException;
    public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG, String[] alphaNumericFieldsNeeded) throws DriverException;
	public String[] getFields();
	public String getWhereClause();
	public String getTableName();
	public void close();
    public void open() throws com.iver.cit.gvsig.fmap.DriverException;
    /**
     * @param FID
     * @return el nmero de registro asociado a ese FID. Se usa dentro
     * del DBStrategy para averigar si un Feature est seleccionado
     * o no.
     */
    public int getRowIndexByFID(IFeature FID);
    public String getGeometryField(String fieldName);
    
    public XMLEntity getXMLEntity();
    /**
     * Para evitar que una clase no se pueda instanciar, 
     * el setXMLEntity debera devolver una referencia
     * a la clase que crea. Ya vorem.
     */
    public void setXMLEntity(XMLEntity xml) throws XMLException;
 
    /**
     * @return information about catalog, fields, tablename, etc
     */
    public DBLayerDefinition getLyrDef();
}
