/*
 * Created on 01-sep-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
*
* $Id: FLayerStatus.java,v 1.1 2006/09/21 17:23:39 azabala Exp $
* $Log: FLayerStatus.java,v $
* Revision 1.1  2006/09/21 17:23:39  azabala
* First version in cvs
*
*
*/
package com.iver.cit.gvsig.fmap.layers;

import java.util.ArrayList;
import java.util.List;

import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.ErrorEvent;

/**
 * Default layer status implementation.
 * 
 * We are trying to model the status of a layer in an object,
 * to get more clarity.
 * 
 * @author azabala
 *
 */
public class FLayerStatus implements IFLayerStatus {

	 public boolean available;
	 public boolean visible;
	 public boolean active;
	 public boolean dirty;
	 public boolean inTOC;
	 public boolean editing;
	 public boolean writable;
	 public boolean cacheDrawnLayers;
	
	 private ArrayList layerErrors;
	
	public FLayerStatus(){
		this.layerErrors = new ArrayList();
		visible = true;
		active = false;
		inTOC = true;
		editing = false;
		cacheDrawnLayers = false;
		dirty = false;
		available = true;
		
		writable = false;
		
	}
	
	public void addLayerError(DriverException error){
		layerErrors.add(error);
	}
	
	public int getNumErrors(){
		return layerErrors.size();
	}
	
	public DriverException getError(int i){
		return (DriverException) layerErrors.get(i);
	}
	
	public boolean isOk(){
		return layerErrors.size() == 0;
	}

	public List getErrors() {
		return layerErrors;
	}
	
}

