/*
 * Created on 19-sep-2005
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.rendering;

import java.awt.Graphics2D;

import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.core.ISymbol;

public class FGraphic {
    int idSymbol;
    IGeometry geom;
    String tag;

    public FGraphic(IGeometry geom, int idSymbol)
    {
        this.idSymbol = idSymbol;
        this.geom = geom;
    }

    /**
     * @return Returns the tag.
     */
    public String getTag() {
        return tag;
    }

    /**
     * @param tag The tag to set.
     */
    public void setTag(String tag) {
        this.tag = tag;
    }

    /**
     * @return Returns the geom.
     */
    public IGeometry getGeom() {
        return geom;
    }

    /**
     * @param geom The geom to set.
     */
    public void setGeom(IGeometry geom) {
        this.geom = geom;
    }

    /**
     * @return Returns the idSymbol.
     */
    public int getIdSymbol() {
        return idSymbol;
    }

    /**
     * @param idSymbol The idSymbol to set.
     */
    public void setIdSymbol(int idSymbol) {
        this.idSymbol = idSymbol;
    }

    /**
     * Draws graphic with the assigned symbol.
     * Override this method if you need more graphics, like
     * FGraphicLabel
     * @param g
     * @param viewPort
     * @param theSymbol
     */
    public void draw(Graphics2D g, ViewPort viewPort, ISymbol theSymbol )
    {
        if (theSymbol.isShapeVisible())
        {
            IGeometry cloneGeom = geom.cloneGeometry();
            cloneGeom.draw(g,viewPort,theSymbol);
        }
    }

}
