package com.hardcode.gdbms.engine.strategies;

import com.hardcode.gdbms.engine.instruction.CustomAdapter;
import com.hardcode.gdbms.engine.instruction.SelectAdapter;
import com.hardcode.gdbms.engine.instruction.UnionAdapter;


/**
 * Manejador de las distintas estrategias disponibles para ejecutar las
 * instrucciones
 *
 * @author Fernando Gonzlez Corts
 */
public class StrategyManager {
	/**
	 * Obtiene la estrategia ms adecuada en funcin de la instruccin a
	 * ejecutar y de las condiciones actuales del sistema
	 *
	 * @param instr Instruccin que se desea ejecutar
	 *
	 * @return estrategia capaz de ejecutar la instruccin
	 */
	public static Strategy getStrategy(SelectAdapter instr) {
		return new FirstStrategy();
	}

	/**
	 * Obtiene la estrategia ptima para ejecutar la instruccin de union que
	 * se pasa como parmetro
	 *
	 * @param instr instruccin que se quiere ejecutar
	 *
	 * @return
	 */
	public static Strategy getStrategy(UnionAdapter instr) {
		return new FirstStrategy();
	}

	/**
	 * Gets the only strategy to execute custom queries
	 *
	 * @param instr root node of the custom query to execute
	 *
	 * @return Strategy
	 */
	public static Strategy getStrategy(CustomAdapter instr) {
		return new FirstStrategy();
	}
}
