/*
 * Created on 01-sep-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: ExceptionDescription.java,v 1.2 2006/09/22 08:08:04 ldiaz Exp $
 * $Log: ExceptionDescription.java,v $
 * Revision 1.2  2006/09/22 08:08:04  ldiaz
 * layerName y driverName gestionados/almacenados desde esta clase
 *
 * Revision 1.1  2006/09/21 17:04:52  azabala
 * First version in cvs
 *
 *
 */
package com.iver.utiles;

/**
 * A Exception could be caused for many reasons. <br>
 * All exception instances that we want to give more information will have a
 * ExceptionDescription, which will describe the cause of the error, so we'll
 * have more information to give to user.
 * 
 * @author azabala
 * 
 */
public abstract class ExceptionDescription {

	private int errorCode;

	/**
	 * Descriptive exception description for the programmer.
	 */
	private String errorDescription;
	private String driverName;
	private String layerName;
	
	public String getDriverName() {
		return driverName;
	}
	public void setDriverName(String driverName){
		this.driverName = driverName;
	}	
	public String getLayerName() {
		return driverName;
	}
	public void setLayerName(String layerName){
		this.layerName = layerName;
	}	
	public ExceptionDescription() {
	}

	public ExceptionDescription(int errorCode, String errorDescription) {
		this.errorCode = errorCode;
		this.errorDescription = errorDescription;
	}

	public void setCode(int errorCode) {
		this.errorCode = errorCode;
	}

	public void setDescription(String description) {
		this.errorDescription = description;
	}

	public int getErrorCode() {
		return errorCode;
	}

	public String getErrorDescription() {
		return errorDescription;
	}

	public abstract String getHtmlErrorMessage();

}